select
    an.numero as "Nmero"
    , up.data as "Data do ltimo parto"
    , uc.dtfim as "Data da ltima secagem"
    , pp.data as "Data do penltimo parto"
    , pc.dtfim as "Data da penltima secagem"
    , (coalesce((select count (*) from lactacao re1 where re1.cdanimal = an.cdanimal), 0) + coalesce(an.numpartoentrada, 0)) as "N de lactaes atual"
    , (case
        when an.dtbaixa is null then (current_date - ul.dtinicio)
        else null end) as "DEL na data atual"
  ,  (case sp.cprodutiva when 3 then 'Seca' when 4 then 'Em lactao' else null end) as "Situao produtiva"
  ,  (case when an.dtbaixa is not null then 'Baixada' else null end) as "Situao"
    , (case
        when ((up.data > uc.dtfim) and (an.dtbaixa is null)) then up.data - uc.dtfim
        when ((up.data < uc.dtfim) and (an.dtbaixa is null)) then current_date - uc.dtfim
        else null end) as "Dias em relao  secagem"
    , (uc.dtfim - uc.dtinicio) as "DEL na ltima secagem"
    , (pc.dtfim - pc.dtinicio) as "DEL na penltima secagem"
    , (case up.retencaoplacenta
        when 0 then 'No'
        when 1 then 'Sim'
    else null end) as "Reteno no ltimo parto"
    , (select first 1 rem.valor
        from medida rem
        where rem.cdanimal = up.cdanimal
            and rem.dtmedida = up.data
            and rem.cdtipomedida = 2) as "Escore ltimo parto"
    , (select rea.descricao
        from auxilioparto rea
        where rea.cdauxilioparto = up.cdauxilioparto) as "Dificuldade no ltimo parto"
    , (select producaototal from sp_calculaproducaototal (ul.cdlactacao, (coalesce(ul.dtfim, an.dtbaixa, current_date)))) as "Prod. total lt. lactao"
    , (select producaototal from sp_calculaproducaototal (pl.cdlactacao, pl.dtfim)) as "Prod. total penlt. lactao"
    , (select first 1 re.pesototal
        from leite re
        where re.cdanimal = an.cdanimal
            and re.dtleite = uc.dtfim) as "Leite dia secagem lt. lac."
    , (select first 1 re.pesototal
        from leite re
        where re.cdanimal = an.cdanimal
            and re.dtleite = pc.dtfim) as "Leite dia secagem penlt. lac."
    , (select first 1 re.pesototal
        from leite re
        where re.cdanimal = an.cdanimal
            and re.dtleite = (uc.dtfim - 7)) as "Leite 7d. antes sec. lt. lac."
    , (select first 1 re.pesototal
        from leite re
        where re.cdanimal = an.cdanimal
            and re.dtleite = (pc.dtfim-7)) as "Leite 7d. a. sec. penlt. lac."
from
    animal an
    join reproducao up on up.cdreproducao =
        (select first 1 rer.cdreproducao
            from reproducao rer
            where rer.cdtiporeproducao = 7
                and rer.cdanimal = an.cdanimal
            order by rer.data desc)
    left join lactacao uc on uc.cdlactacao =
        (select first 1 rel.cdlactacao
            from lactacao rel
            where rel.cdanimal = an.cdanimal
                and rel.dtfim is not null
            order by rel.dtfim desc)
    left join reproducao pp on pp.cdreproducao =
        ((select first 1 rer.cdreproducao
            from reproducao rer
            where rer.cdtiporeproducao = 7
                and rer.cdanimal = an.cdanimal
                and rer.data < up.data
            order by rer.data desc))
    left join lactacao pc on pc.cdlactacao =
        (select first 1 rel.cdlactacao
            from lactacao rel
            where rel.cdanimal = an.cdanimal
                and rel.dtfim is not null
                and rel.dtfim < uc.dtfim
            order by rel.dtfim desc)
    left join lactacao ul on ul.cdlactacao =
        (select first 1 rel.cdlactacao
            from lactacao rel
            where rel.cdanimal = an.cdanimal
                and rel.dtfim is null
            order by rel.dtinicio desc)
    left join lactacao pl on pl.cdlactacao =
        (select first 1 rel.cdlactacao
            from lactacao rel
            where rel.cdanimal = an.cdanimal
                and rel.dtinicio < ul.dtinicio
            order by rel.dtinicio desc)
  join sp_categoriaanimal(current_date, '') sp on sp.animal = an.cdanimal
where
    an.tipoanimal = 'A'
    and an.animalrebanho = 1
    and an.sexo = 'F'
--- O FILTRO A SEGUIR PODE SER USADO PARA ESPECIFICAR O PERODO DE OCORRNCIA DOS LTIMO PARTOS.
--- LEMBRE-SE DE QUE O FORMATO DAS DATAS PARA UTILIZAR O FILTRO 
---- ANO COM QUATRO DGITOS - MS COM QUATRO DGITOS - DIA COM QUATRO DGITOS
---- AAAA-MM-DD ---
    and up.data between '1900-01-01' and '2200-01-01'
order by an.numordenado
